unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls;

type
  
  { TForm1 }

  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure PaintBox1Paint(Sender: TObject);
  private
    X, Y: Integer;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  LCLType;

{ TForm1 }

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  Paintbox1.Canvas.Brush.Color := clWhite;
  Paintbox1.Canvas.FillRect(0, 0, Paintbox1.Width, Paintbox1.Height);
  Paintbox1.Canvas.Pen.Width := 5;
  Paintbox1.Canvas.Pen.Color := clWhite;
  Paintbox1.Canvas.Pen.Mode := pmXOR;
  Paintbox1.Canvas.Line(X, 0, X, Paintbox1.Height);
  Paintbox1.Canvas.Line(0, Y, Paintbox1.Width, Y);
  Paintbox1.Canvas.Pen.Mode := pmCopy;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin
  if (Key = VK_LEFT) and (X > 0) then
  begin
    Paintbox1.Repaint;
    dec(X);
    Paintbox1.Repaint;
  end else
  if (Key = VK_RIGHT) and (X < Paintbox1.Width) then
  begin
    Paintbox1.Repaint;
    inc(X);
    Paintbox1.Repaint;
  end else
  if (Key = VK_UP) and (Y > 0) then
  begin
    Paintbox1.Repaint;
    dec(Y);
    Paintbox1.Repaint;
  end else
  if (Key = VK_DOWN) and (Y < Paintbox1.Height) then
  begin
    Paintbox1.Repaint;
    inc(Y);
    Paintbox1.Repaint;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  X := Paintbox1.Width div 2;
  Y := Paintbox1.Height div 2;
end;

end.

